# Class TransformManager4D

java.lang.Object
org.jmol.viewer.TransformManager
org.jmol.viewer.TransformManager4D

public class TransformManager4D extends TransformManager

## Field Summary

### Fields inherited from class TransformManager

`aaTest1, antialias, aperatureAngle, bsFrameOffsets, camera, cameraDepth, cameraDepthSetting, cameraDistance, cameraDistanceFromCenter, cameraScaleFactor, cameraSetting, DEFAULT_STEREO_DEGREES, DEFAULT_VISUAL_RANGE, defaultMode, degreesPerRadian, depthValue, doTransform4D, fixedRotationAxis, fixedRotationCenter, fixedRotationOffset, fixedTranslation, fScrPtSafe, haveNotifiedNaN, height, internalRotationAxis, internalSlab, internalTranslation, isSpinFixed, isSpinInternal, matrixRotate, matrixStereo, matrixTemp, matrixTemp3, matrixTest, matrixTransform, matrixTransformInv, MAXIMUM_ZOOM_PERCENTAGE, mode, MODE_NAVIGATION, MODE_PERSPECTIVE_PYMOL, MODE_STANDARD, modelCenterOffset, modelRadius, modelRadiusPixels, movetoThread, NAV_MODE_IGNORE, NAV_MODE_NEWXY, NAV_MODE_NEWXYZ, NAV_MODE_NEWZ, NAV_MODE_NONE, NAV_MODE_RESET, NAV_MODE_ZOOMED, navFps, navigating, navigationCenter, navigationDepthPercent, navigationOffset, navigationShiftXY, navigationSlabOffset, navMode, navOn, navX, navY, navZ, perspectiveDepth, perspectiveModel, perspectiveOffset, perspectiveShiftXY, previousX, previousY, prevZoomSetting, ptTest1, ptTest2, ptTest3, referencePlaneOffset, scale3D, scaleDefaultPixelsPerAngstrom, screenPixelCount, slabEnabled, slabValue, spinFps, spinOn, spinThread, spinX, spinY, spinZ, splitFrameCurrentlyRendering, untransformedPoint, vectorSpinOnly, vectorTemp, vibrationOn, vibrationPeriodMs, vibrationThread, visualRangeAngstroms, vwr, width, windowCentered, zDepthPercentSetting, zDepthValue, zmPct, zoomEnabled, zoomFactor, zShadeEnabled, zSlabPercentSetting, zSlabPoint, zSlabValue`

## Constructor Summary

Constructors
Constructor
Description
`TransformManager4D()`

## Method Summary

Modifier and Type
Method
Description
`void`
`calcTransformMatrix()`
`protected void`
`getScreenTemp(T3 ptXYZ, P3 fScrPt)`
`void`
`resetRotation()`
`protected void`
`rotate4DBall(float xDelta, float yDelta, float zDelta)`
`protected void`
`rotateXYBy(float xDelta, float yDelta, BS bsAtoms)`
`void`
`setAsBallRotation(M4 m, float scale, float dx, float dy, float dz)`
4D ball rotation from nominal dx, dy, dz motion.

### Methods inherited from class TransformManager

`calcCameraFactors, calcNavigationPoint, calcSlabAndDepthValues, centerAt, defaultScaleToScreen, depthToPercent, finalizeTransformParameters, getCameraDepth, getCameraFactors, getMoveToText, getNavigationOffset, getNavigationOffsetPercent, getNavigationState, getNavigationText, getNavPtHeight, getPerspectiveDepth, getPerspectiveFactor, getRotation, getRotationQ, getSlabPercentSetting, getTranslationScript, getTranslationXPercent, getTranslationYPercent, getVibrationPoint, getZoomSetting, homePosition, isInPosition, isNavigating, isWindowCentered, moveRotationCenter, moveToPyMOL, navigateAxis, navigateList, navTranslatePercentOrTo, percentToPixels, resetNavigationPoint, rotate3DBall, rotateAxisAngle, rotateAxisAngleRadiansFixed, rotateAxisAngleRadiansInternal, rotatePoint, rotateXRadians, rotateYRadians, rotateZRadians, scaleToPerspective, scaleToScreen, setAll, setCamera, setCameraDepthPercent, setCenterAt, setNavFps, setNavigatePt, setNavigationDepthPercent, setNavigationOffsetRelative, setNavOn, setNavXYZ, setRotation, setRotationRadius, setSlabDepthInternal, setSlabRange, setSpinOff, setSpinOn, setVibrationPeriod, setVibrationT, setZoomHeight, slabInternal, slabReset, slabToPercent, stopMotion, transformPt, transformPt2D, transformPt3f, transformPt3fSafe, transformPtNoClip, transformPtSafe, transformPtScr, transformPtScrSafe, transformPtScrT3, transformPtVib, transformPtVibSafe, translateToPercent, unscaleToScreen, unTransformPoint, xyzIsSlabbedInternal, zoomBy, zoomToPercent, zValueFromPercent`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### TransformManager4D

public TransformManager4D()

## Method Details

### resetRotation

public void resetRotation()

Overrides:
  `resetRotation` in class `TransformManager`

### rotateXYBy

protected void rotateXYBy(float xDelta, float yDelta, BS bsAtoms)

Overrides:
  `rotateXYBy` in class `TransformManager`

### rotate4DBall

protected void rotate4DBall(float xDelta, float yDelta, float zDelta)

### setAsBallRotation

public void setAsBallRotation(M4 m, float scale, float dx, float dy, float dz)
4D ball rotation from nominal dx, dy, dz motion.

Parameters:
  `m` -
  `scale` -
  `dx` -
  `dy` -
  `dz` -

### calcTransformMatrix

public void calcTransformMatrix()

Overrides:
  `calcTransformMatrix` in class `TransformManager`

### getScreenTemp

protected void getScreenTemp(T3 ptXYZ, P3 fScrPt)

Overrides:
  `getScreenTemp` in class `TransformManager`